/////////////////  Exemple 2 - buttonExample2.cpp  //////////////

// Que ca-t-il se passer lorsque l'utilisateur va aller cliquer sur le bouton et repartir ?

#include <gtkmm/main.h>
#include <gtkmm/button.h>
#include <gtkmm/window.h>

void go_out() {
  printf("Leave !\n");
}

class myButton : public Gtk::Button
{
  public:
    myButton(){};
    virtual ~myButton(){};

  public:
    //Déclaration d'une méthode (un callback) :
    void enter();
};

int main(int argc, char *argv[])
{
  Gtk::Main kit(argc, argv);

  Gtk::Window win;
  win.set_title("buttonExample2 - mem_fun et ptr_fun");
  win.set_border_width(10);
  
  myButton button;
  win.add(button);
  
  // Connexion du signal leave à la méthode clicked
  button.signal_enter().connect( sigc::mem_fun(button, &myButton::enter) );
  // Connexion du signal leave à la fonction globale go_out
  button.signal_leave().connect( sigc::ptr_fun(&go_out) );
  
  button.show();
  
  Gtk::Main::run(win);

  return 0;
};

void myButton::enter()
{
  printf("Enter!\n");
}
