
/////////////////  Exemple 4 - buttonExample_bind.cpp  ///////////////////

// Que se passe-t-il lorsqu'on clique sur le bouton ?

#include <iostream>
#include <gtkmm/main.h>
#include <gtkmm/button.h>
#include <gtkmm/window.h>

int x=10;

bool test_bind_return() {
	std::cout << "test_bind_return()" << std::endl;
};


void test_bind(int i, double d) {
	std::cout << "test_bind() : " << i << ", " << d << std::endl;
};


// Quel sera l'affichage de cette fonction si on clique plusieurs fois de suite ?? Pourquoi ?
void test_bind2(int i) {
	std::cout << "test_bind2() : " << i << std::endl;
	x++;
};

int main(int argc, char *argv[])
{
  Gtk::Main kit(argc, argv);

  Gtk::Window win;
  win.set_title("buttonExample Binding demo");
  win.set_border_width(10);
  
  Gtk::Button button;
  button.set_label("Cliquez SVP !");
  win.add(button);
  button.show();

  button.signal_clicked().connect( sigc::hide_return( sigc::ptr_fun( &test_bind_return ) ) );
  button.signal_clicked().connect( sigc::bind<int, double>( sigc::ptr_fun( &test_bind), 2, 4.56) );
  button.signal_clicked().connect( sigc::bind<int>( sigc::ptr_fun( &test_bind2 ), x) );
  
  Gtk::Main::run(win);

  return 0;
};


