
#include <gtkmm/main.h>
#include <gtkmm/window.h>
#include <gtkmm/eventbox.h>
#include <gtkmm/label.h>
#include <gtkmm/box.h>

int main(int argc, char *argv[])
{
  Gtk::Main kit(argc, argv);

  Gtk::Window win;
  win.set_title("Pack example");
  win.set_border_width(10);

  Gtk::Label m_label1("1"), m_label2("2"), m_label3("3");
  Gtk::EventBox m_eventbox1,m_eventbox2,m_eventbox3;
  Gtk::VBox m_box;
  
  m_eventbox1.add(m_label1);
  m_eventbox2.add(m_label2);
  m_eventbox3.add(m_label3);
  
  m_label1.show();
  m_label2.show();
  m_label3.show();
  
  m_eventbox1.modify_bg( Gtk::STATE_NORMAL, Gdk::Color("yellow") );
  m_eventbox2.modify_bg( Gtk::STATE_NORMAL, Gdk::Color("green") );
  m_eventbox3.modify_bg( Gtk::STATE_NORMAL, Gdk::Color("red") );
  
  bool expand=true; //Indique si le box doit s'étirer avec le parent
  bool fill=true; //Indique si les widgets du box doivent s'étirer avec le box ! (uniquement si expanding = true)
  int padding=10;  //minimum d'espace entre les widgets du box
  
  m_box.pack_start(m_eventbox1, expand, fill, padding);
  m_box.pack_start(m_eventbox2, true, fill, padding);
  m_box.pack_start(m_eventbox3, expand, fill, padding);
  
  m_box.show_all();
  
  win.add(m_box);

  Gtk::Main::run(win);

  return 0;
};
