///////////////// test_cairo1.cc /////////////////////
/*
Test les problèmes de référentiel de dessin !

ISTIC, M2 GL, Module OCI
T. Guyet, Agrocampsu-ouest, 2010
*/


#include <stdlib.h>
#include <gtkmm.h>
#include <assert.h>
#include <iostream>

using namespace Gtk;

class MonLabel : public Gtk::Label
{
  public:
    MonLabel(){};
    virtual ~MonLabel(){};

  protected:
    virtual bool on_expose_event(GdkEventExpose* event);
};

int main(int argc, char *argv[])
{
  Gtk::Main kit(argc, argv);
  
  Window window;
  
  MonLabel m_label;
  Label m_label1("C'est beau !");
	HBox m_box;
  window.add(m_box);
  m_box.pack_start(m_label1);
  m_box.pack_start(m_label);
  window.show_all();

  window.set_size_request(400,600);
  
  Gtk::Main::run(window);
  return EXIT_SUCCESS;
};


bool MonLabel::on_expose_event(GdkEventExpose* event)
{
  Glib::RefPtr<Gdk::Window> window = get_window();

  Gtk::Allocation allocation = get_allocation();
  int x0 = allocation.get_x();
  int y0 = allocation.get_y();
  const int width = allocation.get_width();
  const int height = allocation.get_height();
  
  int x1 =x0+width, y1 =y0+height;

  std::cout << "Le widget se trouve à la position " << x0 << ", "<<y0 << std::endl;

	/* Décommentez pour tester les problèmes de référentiels
	x0 =0;
  y0 =0;
	//*/

  if(window) {
    Cairo::RefPtr<Cairo::Context> cr = window->create_cairo_context();
    assert(cr);

    // !!ATTENTION!! ici, cr est le contexte de la fenêtre, les coordonnées doivent être données dans le référentiel de la fenêtre !!


    //Ici, on définit le clip de sorte à ne redessiner que la partie demandé par l'évènement Expose Event
    cr->rectangle(event->area.x, event->area.y, event->area.width, event->area.height);
    cr->clip();
    
    cr->save();
    
    //Définition de la forme : une croix
    cr->move_to(x0, y0);
    cr->line_to(x1, y1);
    cr->move_to(x0, y1);
    cr->line_to(x1, y0);
    
    //Attribution des propriétés pour le dessin
    cr->set_source_rgb( 0.8, 0, 0 );
    cr->set_line_width(2);  
    cr->set_line_width(2);  
    
    //Réalisation du contour
    cr->stroke();
    
    cr->restore();
  }
};

