///////////////// test_cairo2.cc /////////////////////
/*
Test de la surcharge du dessin d'un widget (ici, un bouton)

ISTIC, M2 GL, Module OCI
T. Guyet, Agrocampsu-ouest, 2010
*/
#include <stdlib.h>
#include <gtkmm.h>
#include <assert.h>
#include <math.h>
#include <iostream>

using namespace Gtk;

void coucou() {
	std::cout << "coucou\n";
}

class MonBouton : public Button
{
  public:
    MonBouton():Button("test"){};
    virtual ~MonBouton(){};

  protected:
    virtual bool on_expose_event(GdkEventExpose* event);
};

int main(int argc, char *argv[])
{
  Gtk::Main kit(argc, argv);
  
  Window window;
  
  MonBouton m_button;
	Label m_label("cliquez sur ce bouton :");
	VBox m_box;
  window.add(m_box);
  m_box.pack_start(m_label);
  m_box.pack_start(m_button);
  
  window.show_all();
	m_button.signal_clicked().connect( sigc::ptr_fun( &coucou ) );

  window.set_size_request(200,200);

  Gtk::Main::run(window);
  return EXIT_SUCCESS;
};

bool MonBouton::on_expose_event(GdkEventExpose* event)
{

	//On dessine ce à quoi doit ressembler le bouton :
  //Essayer de supprimer cet appel de fonction pour rigoler : quid de la possibilité de cliquer sur ce widget ???
  Button::on_expose_event(event);

	//Maintenant, on continue à dessiner par dessus

  Glib::RefPtr<Gdk::Window> window = get_window();

  Gtk::Allocation allocation = get_allocation();
  const int x0 = allocation.get_x();
  const int y0 = allocation.get_y();
  const int width = allocation.get_width();
  const int height = allocation.get_height();
  
  double x1 =(double)(x0+width), y1 =(double)(y0+height);
  
  if(window) {
    Cairo::RefPtr<Cairo::Context> cr = window->create_cairo_context();
    assert(cr);
        
    //Ici, on définit le clip de sorte à ne redessiner que la partie demandé par l'évènement Expose Event
    cr->rectangle(event->area.x, event->area.y, event->area.width, event->area.height);
    cr->clip();
    
    cr->save();
    
    //Définition de la forme : un arc
    cr->arc(x0+width/2, y0+height/2, /*line_width*/ 50.0, /*angle1*/ M_PI/2, /*angle2*/ 2 * M_PI);
    
    //Attribution des propriétés pour le dessin
    cr->set_source_rgb(0.3, 0.6, 0.1);
    
    //Réalisation de l'intérieur
    cr->stroke();
    
    cr->restore();
  }
};

