///////////////// test_cairo3.cc /////////////////////
/*
Exemple simple de cairo :
- utilisation de stroke et de fill (+effet du preserve)
- définition de pointillés

ISTIC, M2 GL, Module OCI
T. Guyet, Agrocampsu-ouest, 2010
*/
#include <stdlib.h>
#include <gtkmm.h>
#include <assert.h>
#include <math.h>
#include <vector>


using namespace Gtk;

class MonLabel : public Gtk::Label
{
  public:
    MonLabel(){};
    virtual ~MonLabel(){};

  protected:
    virtual bool on_expose_event(GdkEventExpose* event);
};

int main(int argc, char *argv[])
{
  Gtk::Main kit(argc, argv);
  
  Window window;
  
  MonLabel m_label;
  window.add(m_label);
  
  m_label.show();

  window.set_size_request(400,600);
  
  Gtk::Main::run(window);
  return EXIT_SUCCESS;
};


bool MonLabel::on_expose_event(GdkEventExpose* event)
{
  Glib::RefPtr<Gdk::Window> window = get_window();

  Gtk::Allocation allocation = get_allocation();
  const int width = allocation.get_width();
  const int height = allocation.get_height();
  
  double x0 =10, y0 =10, x1 =(double)width-10, y1 =(double)height-10;
  
  if(window) {
    Cairo::RefPtr<Cairo::Context> cr = window->create_cairo_context();
    assert(cr);
        
    //Ici, on définit le clip de sorte à ne redessiner que la partie demandé par l'évènement Expose Event
    cr->rectangle(event->area.x, event->area.y, event->area.width, event->area.height);
    cr->clip();
    
    cr->save();
    
    //Définition de la forme : un rectangle
    cr->rectangle(x0, y0, /*width*/x1-x0, /*height*/y1-y0);
    
    //Attribution des propriétés pour le dessin
    cr->set_source_rgb(0.3, 0.6, 0.1);
    
    //Réalisation de l'intérieur avec conservation de la forme
    cr->fill_preserve();

    //Changement des attributs de dessin
    cr->set_source_rgb(0.8, 0, 0);

    //On va faire des pointillés !
	std::vector<double> dashed;
	dashed.push_back(4.0);
	dashed.push_back(2.0);
	static int len  = dashed.size() / dashed.front();

	cr->set_dash(dashed, len);

	// on ajoute une croix au chemin précédent
    cr->move_to(x0, y0);
    cr->line_to(x1, y1);
    cr->move_to(x0, y1);
    cr->line_to(x1, y0);

	//On réalise le contour (avec la même forme qu'avant + la croix)
    cr->stroke();
    
    cr->restore();
  }
};

