///////////////// test_cairo4.cc /////////////////////
/*
Chargement d'une image (et redimensionnement)

ISTIC, M2 GL, Module OCI
T. Guyet, Agrocampsu-ouest, 2010
*/
#include <stdlib.h>
#include <stdio.h>
#include <stdlib.h>
#include <gtkmm.h>
#include <assert.h>
#include <math.h>


using namespace Gtk;

class MonLabel : public Gtk::Label
{
  public:
    MonLabel(){};
    virtual ~MonLabel(){};

  protected:
    virtual bool on_expose_event(GdkEventExpose* event);
};

int main(int argc, char *argv[])
{
  Gtk::Main kit(argc, argv);
  
  Window window;
  
  MonLabel m_label;
  window.add(m_label);
  
  m_label.show();

  window.set_size_request(600,400);
  
  Gtk::Main::run(window);
  return EXIT_SUCCESS;
};


bool MonLabel::on_expose_event(GdkEventExpose* event)
{
  Glib::RefPtr<Gdk::Window> window = get_window();

  Gtk::Allocation allocation = get_allocation();
  const int width = allocation.get_width();
  const int height = allocation.get_height();
  
  int w,h;
  
  if(window) {
    Cairo::RefPtr<Cairo::Context> cr = window->create_cairo_context();
    assert(cr);
      
    //Définition de la forme : une croix
    Cairo::RefPtr<Cairo::ImageSurface> image;

    try {
      image = Cairo::ImageSurface::create_from_png("./imgp3220.png");
    }
    catch(std::exception& e) {
      printf("Exception on Image what: %s \n",e.what() );
      exit(EXIT_FAILURE);
    }
    
    w = image->get_width();
    h = image->get_height();
    
    cr->save();
    
    //Définition de la zone à afficher (toute la fenêtre)
    cr->rectangle(0.0, 0.0, width, height);
    cr->clip();
    
    //Scale le CR de sorte à avoir une image qui prenne toute la place
    cr->scale( (double)width/(double)w, (double)height/(double)h);
    
    //Définit la surface
    cr->set_source(image, 0.0, 0.0);
    
    //Réalise l'affichage de la surface
    cr->paint();
    
    image->finish();
    
    cr->restore();
  }
};

